/* eslint-disable no-console */
import React from 'react';
import PropTypes from 'prop-types';
import ReactDOM from 'react-dom';
import Context from '@s-ui/react-context';
import { Provider as ProviderLegacy } from '@s-ui/react-domain-connector';
import { useMount } from '@s-ui/react-hooks';

function renderWidgetOnDOM(_ref) {
  var children = _ref.children,
      context = _ref.context,
      node = _ref.node;
  ReactDOM.render( /*#__PURE__*/React.createElement(Context.Provider, {
    value: context
  }, /*#__PURE__*/React.createElement(ProviderLegacy, context, children)), node);
}

export default function Widget(_ref2) {
  var browser = _ref2.browser,
      children = _ref2.children,
      contextFromProps = _ref2.context,
      domain = _ref2.domain,
      i18n = _ref2.i18n,
      _ref2$isVisible = _ref2.isVisible,
      isVisible = _ref2$isVisible === void 0 ? true : _ref2$isVisible,
      node = _ref2.node,
      selector = _ref2.selector,
      _ref2$renderMultiple = _ref2.renderMultiple,
      renderMultiple = _ref2$renderMultiple === void 0 ? false : _ref2$renderMultiple;
  useMount(function () {
    var selectorToUse = selector || node;

    if (!selectorToUse) {
      return console.warn("[Widget] You must define a selector or node (deprecated) to use the Widget");
    }

    var nodes = document.querySelectorAll(selectorToUse);

    if (!nodes.length) {
      return console.warn("[Widget] unable find nodes using selector " + selectorToUse);
    } // depending on renderMultiple, get the full array or only the first one


    var nodesToRender = renderMultiple ? [].slice.call(nodes) : [nodes[0]]; // create the context object

    var context = contextFromProps || {
      browser: browser,
      domain: domain,
      i18n: i18n
    };
    isVisible && nodesToRender.map(function (node) {
      return renderWidgetOnDOM({
        children: children,
        context: context,
        node: node
      });
    });
  });
  return null;
}
Widget.propTypes = {
  browser: PropTypes.object,
  children: PropTypes.element.isRequired,
  domain: PropTypes.object,
  i18n: PropTypes.object,
  isVisible: PropTypes.bool,
  node: function node() {
    return new Error('Prop `node` is deprecated and it will be removed in the next major version. Use `selector` instead for passing the CSS Path.');
  },
  selector: PropTypes.string.isRequired
};